# $Revision: 1.57 $, $Date: 2007/01/29 19:23:37 $
# TODO
# - separate package for jsdk?
#
# Conditional build:
%bcond_with	gcj	# use GCJ instead of javac
#
%define		apxs		/usr/sbin/apxs1
%define		jsdkversion	20000924
%define		mod_name	jserv
Summary:	Servlet engine with support for the leading web server
Summary(pl):	Silnik serwletw ze wsparciem dla wiodcego serwera WWW
Name:		ApacheJServ
Version:	1.1.2
Release:	3
License:	freely distributable & usable (JServ), LGPL (JSDK)
Group:		Networking/Daemons
Source0:	http://java.apache.org/jserv/dist/%{name}-%{version}.tar.gz
# Source0-md5:	6d48a1b9fcc5eea4dfebaae29ba5a485
Source1:	http://www.euronet.nl/~pauls/java/servlet/download/classpathx_servlet-%{jsdkversion}.tar.gz
# Source1-md5:	a81feddb91b1358f9aaed94e83eddb54
Source2:	%{name}.conf
Source3:	%{name}.init
Source4:	%{name}.sysconfig
Source5:	runjserv
Patch0:		%{name}-enable-secret.patch
Patch1:		%{name}-ac.patch
Patch2:		%{name}-jre-env.patch
Patch3:		%{name}-config.patch
URL:		http://java.apache.org/
BuildRequires:	apache1-devel >= 1.3.9-8
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	gettext-devel
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	sed >= 4.0
%if %{with gcj}
BuildRequires:	fastjar
BuildRequires:	gcc-java
BuildRequires:	jdkgcj
Requires:	/usr/bin/gij
%else
BuildRequires:	java-sun
Requires:	java-sun-jre
%endif
Requires(post,preun):	rc-scripts
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	%{name} = %{version}-%{release}
Requires:	rc-scripts >= 0.4.0.19
Provides:	group(jserv)
Provides:	jsdk20
Provides:	jserv
Provides:	user(jserv)
Obsoletes:	ApacheJServ-init
Obsoletes:	jserv
ExclusiveArch:	i586 i686 pentium3 pentium4 athlon %{x8664}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_pkglibdir	%(%{apxs} -q LIBEXECDIR 2>/dev/null)
%define		httpdconf	%(%{apxs} -q SYSCONFDIR 2>/dev/null)
%define		_sysconfdir	/etc/jserv
%define		logdir		/var/log/jserv
%define		_noautocompressdoc  package-list

%description
Apache JServ is a servlet engine, developed by the Java Apache Project
<http://java.apache.org/>. The Apache JServ servlet engine is written
in 100pc Java application, and listens for servlet requests using the
Apache Java protocol (AJp). Typically, these requests will originate
from the mod_jserv Apache module (DSO included). This package contains
a LGPL'ed implementation of Sun's Java Servlet API version 2.0 by Paul
Siegmann <http://www.euronet.nl/~pauls/java/servlet/>.

%description -l pl
Apache JServ jest silnikiem serwletowym, rozwijanym przez Java Apache
Project <http://java.apache.org/>. Silnik serwletowy Apache JServ
zosta napisany od pocztku do koca w Javie; nasuchuje wywoa
serwletu wykorzystujc protok Apache Java (AJp). Zazwyczaj wywoania
te pochodz z moduu Apache mod_jservmodule (cznie z DSO). Pakiet
ten zawiera implementacj Java Servlet API Suna w wersji 2.0 napisan
przez Paula Siegmanna (na licencji LGPL)
<http://www.euronet.nl/~pauls/java/servlet/>.

%package -n apache1-mod_jserv
Summary:	JServ module for Apache
Summary(pl):	Modu JServ dla Apache'a
Group:		Networking/Daemons
Requires:	apache1 >= 1.3.33-2
Obsoletes:	ApacheJServ-auto

%description -n apache1-mod_jserv
JServ module for Apache.

%description -n apache1-mod_jserv -l pl
Modu JServ dla Apache'a.

%package doc
Summary:	ApacheJServ documentation
Summary(pl):	Dokumentacja do ApacheJServ
Group:		Development/Languages/Java

%description doc
ApacheJserv documentation.

%description doc -l pl
Dokumentacja do ApacheJServ.

%prep
%setup -q -a1
%patch0 -p0
%patch1 -p0
%patch2 -p1
%patch3 -p1

sed -i -e '
	s|@JSDK_CLASSES@|%{_javadir}/servlet-2.0.jar|g
' conf/jserv.properties.in

# do not load module in provided jserv.conf; we do this in httpd.conf
sed -i -e 's|@LOAD_OR_NOT@|#|g' conf/jserv.conf.in

# we don't want gcj related deps
sed -i -e '/^SUBDIRS/s,java,,' src/Makefile.am
sed -i -e '/^SUBDIRS/s,example,,' Makefile.am

%build
export JAVA_HOME="%{java_home}"

if [ ! -f _autotools.done.1 ]; then
	%{__gettextize}
	%{__libtoolize}
	%{__aclocal}
	%{__autoconf}
	%{__automake}
	touch _autotools.done.1
fi

# prepare compilation
if [ ! -f classpathx_servlet-%{jsdkversion}/servlet-2.0.jar ]; then
	%{__make} -C classpathx_servlet-%{jsdkversion} jar_2_0
fi

if [ ! -d jsdk-doc ]; then
	%{__make} -C classpathx_servlet-%{jsdkversion}/apidoc

	# copy API-doc
	mkdir jsdk-doc
	cp classpathx_servlet-%{jsdkversion}/{README,AUTHORS,COPYING.LIB} jsdk-doc
	cp -r classpathx_servlet-%{jsdkversion}/apidoc jsdk-doc
fi

### JSERV
CFLAGS="$(%{apxs} -q CFLAGS) %{rpmcflags}"
dir=$(pwd)
%configure \
	%{!?debug:--disable-debugging} \
	--with-apxs=%{apxs} \
	--with-logdir=%{logdir} \
	--with-servlets=%{_datadir}/jserv/servlets \
	--with-java-platform=1.4 \
	--with-JSDK=$dir/classpathx_servlet-%{jsdkversion}/servlet-2.0.jar \
	%{!?with_gcj:GCJ=javac GCJFLAGS= CLASSPATH=$dir JAVAC_OPT="-source 1.4"} \
	%{!?with_gcj:--with-javac=%{javac} --with-java=%{java} --with-jdk-home=$JAVA_HOME} \
	%{?with_gcj:--with-javac=%{_bindir}/gcj --with-jar=%{_bindir}/fastjar} \

%{__make} %{!?with_gcj:OBJEXT=class JAVAC_OPT='-source 1.4'} \
	-C src/java
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{sysconfig,rc.d/init.d},%{httpdconf}/conf.d,%{_javadir},%{_sbindir}}

install %{SOURCE2} $RPM_BUILD_ROOT%{httpdconf}/conf.d/80_mod_jserv.conf
install %{SOURCE3} $RPM_BUILD_ROOT/etc/rc.d/init.d/jserv
install %{SOURCE4} $RPM_BUILD_ROOT/etc/sysconfig/jserv
install %{SOURCE5} $RPM_BUILD_ROOT%{_sbindir}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# we removed java from SUBDIRS, so do it manually
%{__make} install \
	%{!?with_gcj:OBJEXT=class JAVAC_OPT='-source 1.4'} \
	-C src/java \
	DESTDIR=$RPM_BUILD_ROOT

> $RPM_BUILD_ROOT%{httpdconf}/jserv.secret.key
> $RPM_BUILD_ROOT%{_sysconfdir}/jserv.secret.key

install -d $RPM_BUILD_ROOT%{_datadir}/jserv/servlets

### GNU JSDK-classes
install classpathx_servlet-%{jsdkversion}/servlet-2.0.jar $RPM_BUILD_ROOT%{_javadir}

find jsdk-doc -name 'Makefile*' | xargs rm -f
rm -rf jsdk-doc/{COPYING.LIB,CVS} jsdk-doc/apidoc/CVS

# duplicate
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/jserv.conf
rm -rf $RPM_BUILD_ROOT%{_prefix}/docs

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 154 jserv
%useradd -u 154 -g jserv -d /etc/jserv -c "JServ User" jserv

%post
if [ ! -s %{_sysconfdir}/jserv.secret.key ]; then
	if [ -s %{httpdconf}/jserv.secret.key ]; then
		cat %{httpdconf}/jserv.secret.key > %{_sysconfdir}/jserv.secret.key
	else
		dd if=/dev/urandom bs=1 count=42 2>/dev/null \
			| (md5sum 2>/dev/null || cat) > %{_sysconfdir}/jserv.secret.key
	fi
fi
/sbin/chkconfig --add jserv
%service jserv restart "Apache JServ Daemon"

%preun
if [ "$1" = 0 ]; then
	%service jserv stop
	/sbin/chkconfig --del jserv
fi

%postun
if [ "$1" = "0" ]; then
	%userremove jserv
	%groupremove jserv
fi

%post -n apache1-mod_jserv
if [ ! -s %{httpdconf}/jserv.secret.key ]; then
	if [ -s %{_sysconfdir}/jserv.secret.key ]; then
		cat %{_sysconfdir}/jserv.secret.key > %{httpdconf}/jserv.secret.key
	else
		dd if=/dev/urandom bs=1 count=42 2>/dev/null \
			| (md5sum 2>/dev/null || cat) > %{httpdconf}/jserv.secret.key
	fi
fi
%service -q apache restart

%postun -n apache1-mod_jserv
if [ "$1" = "0" ]; then
	%service -q apache restart
fi

%files
%defattr(644,root,root,755)
%doc LICENSE README
%dir %attr(750,root,jserv) %{_sysconfdir}
%attr(640,root,jserv) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/jserv.secret.key
%attr(640,root,jserv) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/jserv.properties
%attr(640,root,jserv) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/zone.properties
%attr(754,root,root) /etc/rc.d/init.d/jserv
%attr(755,root,root) %{_sbindir}/runjserv
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/jserv
%{_javadir}/ApacheJServ.jar
%{_javadir}/servlet-2.0.jar
%dir %{_datadir}/jserv
%dir %attr(750,root,jserv) %{_datadir}/jserv/servlets

%if 0
%{_datadir}/jserv/servlets/Hello.java
%{_datadir}/jserv/servlets/Hello.class
%{_datadir}/jserv/servlets/IsItWorking.java
%{_datadir}/jserv/servlets/IsItWorking.class
%endif
%attr(770,root,jserv) %dir %{logdir}

%files -n apache1-mod_jserv
%defattr(644,root,root,755)
%attr(755,root,root) %{_pkglibdir}/mod_jserv.so
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{httpdconf}/conf.d/80_mod_jserv.conf
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{httpdconf}/jserv.secret.key

%files doc
%defattr(644,root,root,755)
%doc index.html docs
%doc jsdk-doc

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: ApacheJServ.spec,v $
Revision 1.57  2007/01/29 19:23:37  glen
- EA based on where java-sun is available; rel 3

Revision 1.56  2007/01/29 18:43:26  glen
- rel 2

Revision 1.55  2007/01/08 11:27:03  glen
- builds on amd64 with java-sun

Revision 1.54  2007/01/08 11:04:04  glen
- try new java build method
- updated initscript to run output logged to a file

Revision 1.53  2006/05/24 11:07:40  glen
- drop non-cvs changelog

Revision 1.52  2006/04/06 20:59:28  glen
- mature enough (works for me), rel 1

Revision 1.51  2006/01/06 18:47:21  glen
- added sysconfig
- use %service macro
- disable insecure selfservlet by default

Revision 1.50  2005/12/29 14:07:02  glen
- fixed packaged files

Revision 1.49  2005/12/29 12:40:38  glen
- make just two packages: apache module and jserv runner
  making also automatic restart goes too crazy and probably nobody needs it anyway

Revision 1.48  2005/10/31 16:33:37  qboosh
- pl for -auto

Revision 1.47  2005/10/31 13:42:06  glen
- subpackage for different configs

Revision 1.46  2005/10/22 11:36:21  glen
- cleanups, hacks to get -init package ran as different user

Revision 1.45  2005/10/22 10:50:51  glen
- R: jre

Revision 1.44  2005/10/06 20:44:13  glen
- fix deps for having javadoc

Revision 1.43  2005/09/22 18:54:10  qboosh
- pl for apache1-

Revision 1.42  2005/09/22 18:26:45  glen
- cleanup

Revision 1.41  2005/09/22 17:40:17  glen
- spearate package for apache module
- create constant secret.key file so it's not always created as .rpmnew with upgrade

Revision 1.40  2005/08/24 17:27:15  qboosh
- pl updates and fixes

Revision 1.39  2005/08/23 09:28:28  glen
- user/groupadd to init package
- secret.key fill simplified
- cleanups

Revision 1.38  2005/08/19 17:47:15  glen
- created -init subpackage for standalone mode
- cruft removed from %post (we are rpm!)
- cosmetics & cleanups

Revision 1.37  2005/08/19 16:12:22  glen
- doc subpackage

Revision 1.36  2005/08/19 15:26:00  glen
- compiles, dirty, needs more work

Revision 1.35  2005/08/19 12:29:02  glen
- started work

Revision 1.34  2004/12/14 16:59:55  baggins
- DON'T hardcode java paths!

Revision 1.33  2004/11/04 20:22:40  paladine
- spaces->tabs

Revision 1.32  2004/09/29 16:00:57  kolodko
- added macros in /etc/logrotate.d

Revision 1.31  2004/01/05 20:23:05  ankry
- new head/tail syntax

Revision 1.30  2003/08/06 16:10:18  kloczek
- moe wrescie kto wykasuje to konto ?

Revision 1.29  2003/07/06 23:27:13  blues
- many small fixes, mostly inpired by kloczek

Revision 1.28  2003/05/26 16:24:18  malekith
- massive attack: adding Source-md5

Revision 1.27  2003/05/25 05:45:21  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.26  2003/02/28 10:06:55  trojan
- massive attack: perl -pi -e "s/^#+\%\{/#\%\%\{/"

Revision 1.25  2003/01/18 20:16:32  qboosh
- 1.1.2 (the last version), removed obsolete DESTDIR patch

Revision 1.24  2002/12/29 01:44:28  qboosh
- umask in scripts, other fixes/cosmetics where needed

Revision 1.23  2002/12/07 23:49:18  ankry
- fix improper usage of %{_sysconfdir}

Revision 1.22  2002/12/07 19:10:38  orzech
- /home -> /home/services

Revision 1.21  2002/12/07 14:32:49  ankry
- fix improper usage of %{_sysconfdir}

Revision 1.20  2002/10/09 13:14:13  kloczek
- use more macros, some cosmetics, added missing "rm -f missing" and use new %doc

Revision 1.19  2002/05/21 23:12:35  kloczek
- perl -pi -e "s/^automake -a -c -f --foreing/\%\{__automake\}/; \
            s/^automake -a -c -f/\%\{__automake\}/; \
     s/^autoconf/\%\{__autoconf\}/"

Revision 1.18  2002/04/25 15:44:50  arturs
- fixed a small typo

Revision 1.17  2002/04/05 15:26:37  roman
- s/Freely/freely in License

Revision 1.16  2002/03/24 23:28:12  kloczek
- perl -pi -e "s/^automake -a -c$/automake -a -c -f/"

Revision 1.15  2002/02/23 01:05:31  kloczek
- adapterized.

Revision 1.14  2002/02/22 23:28:36  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.13  2002/01/18 02:12:09  kloczek
- perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.12  2001/08/31 08:27:54  qboosh
- added pl summary, s/Copyright/License/

Revision 1.11  2001/05/02 00:42:06  qboosh
- adapterized and made spec %debug ready or using %rpm*flags macros

Revision 1.10  2001/02/19 17:31:53  kloczek
- more work (still NYF).

Revision 1.9  2001/02/19 16:50:33  siefca
- fixed classpathx_servlet URL

Revision 1.8  2000/06/09 07:54:38  kloczek
- more %{__make} macros.

Revision 1.7  2000/06/09 07:22:44  kloczek
- added using %{__make} macro.

Revision 1.6  2000/05/30 23:23:14  arturs
- added %description -l pl

Revision 1.5  2000/05/17 00:36:12  kloczek
- spec adapterized.

Revision 1.4  2000/04/01 11:14:21  zagrodzki
- changed all BuildRoot definitons
- removed all applnkdir defs
- changed some prereqs/requires
- removed duplicate empty lines

Revision 1.3  2000/03/28 16:54:13  baggins
- translated kloczkish into english

Revision 1.2  2000/02/20 08:50:10  kloczek
- partialy rewrited.
